#ifndef GRAPHICS_SCROLL_H
#define GRAPHICS_SCROLL_H 1

/*
**  scroll.h
**
**  (C) Copyright 1999-2004 Rocklyte Systems.
**      All Rights Reserved.
*/

#ifndef MAIN_H
#include <pandora/main.h>
#endif

/*****************************************************************************
** Axis options.
*/

enum {
   AXIS_X=1,
   AXIS_Y,
   AXIS_Z
};

/*****************************************************************************
** Scroll flags.
*/

#define SCF_AUTOHIDE   0x00000001 /* Automatically hide the scrollbar when possible */
#define SCF_HORIZONTAL 0x00000002 /* The scrollbar is oriented horizontally */
#define SCF_VERTICAL   0x00000004 /* The scrollbar is oriented vertically */
#define SCF_REVERSE    0x00000008 /* Reverses the polarity of the warp engine */
#define SCF_RELATIVE   0x00000010 /* All movement is to be relative */
#define SCF_SLIDER     0x00000020 /* Slide bars are used for precision scrolling rather than page scrolling */
#define SCF_FIXED      0x00000040 /* Fixes the scroll slider to a specific size */

/*****************************************************************************
** Scroll methods.
*/

#define MT_UpdateScroll    -1
#define MT_AddScrollButton -2

struct mtAddScrollButton {
   OBJECTID ButtonID;
   LONG Direction;
};

struct mtUpdateScroll {
   LONG PageSize;
   LONG ViewSize;
   LONG Position;
   LONG Unit;
};

#define SD_NEGATIVE 1
#define SD_POSITIVE 2

#define SD_UP     SD_NEGATIVE
#define SD_DOWN   SD_POSITIVE
#define SD_LEFT   SD_NEGATIVE
#define SD_RIGHT  SD_POSITIVE

#endif /* GRAPHICS_SCROLL_H */
