#ifndef SYSTEM_BROADCAST_H
#define SYSTEM_BROADCAST_H TRUE

/*
**  broadcast.h
**
**  (C) Copyright 1996-2002 Rocklyte Systems.
**      All Rights Reserved.
**
*/

#ifndef MAIN_H
#include <pandora/main.h>
#endif

/*****************************************************************************
** Broadcast methods.
*/

#define MT_Broadcast        -1
#define MT_SubscribeEvent   -2
#define MT_UnsubscribeEvent -3

struct mtBroadcast {
   LONG     EventID;
   OBJECTID ObjectID;
   LARGE    Integer;
   APTR     Buffer;
   LONG     Size;
};

struct mtSubscribeEvent {
   OBJECTID SubscriberID;
   LONG EventID;
};

struct mtUnsubscribeEvent {
   OBJECTID SubscriberID;
   LONG EventID;
};

/*****************************************************************************
** Broadcast event ID's.
*/

#define EVT_NewTask          1
#define EVT_TaskCrashed      2
#define EVT_LowMemory        3
#define EVT_FileCreated      4
#define EVT_FileDeleted      5
#define EVT_ResolutionChange 6
#define TOTAL_EVENTS         7

#endif /* SYSTEM_BROADCAST_H */
