#ifndef SYSTEM_MODULE_H
#define SYSTEM_MODULE_H TRUE

/*
**  module.h
**
**  (C) Copyright 1996-2001 Rocklyte Systems.
**      All Rights Reserved.
**
*/

#ifndef MAIN_H
#include <pandora/main.h>
#endif

#ifndef MODULES_KERNEL_H
#include <pandora/modules/kernel.h>
#endif

/*****************************************************************************
** Function list array structure.
*/

struct Function {
   APTR Address;
   STRING Name;
   struct FunctionField *Args;
};

/*****************************************************************************
** Table-Type definitions.
*/

#define JMP_LVO       1  /* LVO jump type (Amiga standard) */
#define JMP_STRUCTURE 2  /* Base structure (Linux, C/C++ standard)*/

#define JMP_DEFAULT JMP_STRUCTURE
#define JMP_BASE    JMP_STRUCTURE

/*****************************************************************************
** Module file header.
*/

#define MODULE_HEADER_V1 0x4D4F4401

#define MODULE_HEADER EXPORT struct ModHeader ModHeader

struct ModHeader {
   LONG   Version;
   ERROR  (*Init)(OBJECTPTR, struct KernelBase *);
   void   (*Close)(OBJECTPTR);
   ERROR  (*Open)(OBJECTPTR);
   ERROR  (*Expunge)(void);
   LONG   KernelTable;            /* Type of function table to get for the object kernel */
   struct Function *DefaultList;  /* Pointer to default function list */
   LONG   CPUNumber;              /* CPU that this module is compiled for */
   FLOAT  ModVersion;             /* Version of this module */
   FLOAT  MinKernelVersion;       /* Minimum Kernel version required */
   STRING Author;                 /* Author of the module */
   STRING Copyright;              /* Copyright details */
   STRING Date;                   /* Date of compilation */
   STRING Name;                   /* Name of the module */
};

/*****************************************************************************
** Registered CPU ID's.
*/

#define CPU_68000   1
#define CPU_68010   2
#define CPU_68020   3
#define CPU_68030   4
#define CPU_68040   5
#define CPU_68060   6
#define CPU_I286    7
#define CPU_I386    8
#define CPU_I486    9
#define CPU_I586    10
#define CPU_I686    11

#endif /* SYSTEM_MODULE_H */
